/*********************************************************************
 ** Martial Chateauvieux
 **   HORUS UAV System
 ** Septembre 2003
 **********************************************************************
 **
 **    HORUS UAV System V1.1.0 - Copyright (C) 2003-2009 Martial
 **    Chateauvieux
 **
 **    This file is part of the HORUS UAV System distribution.
 **
 **    HORUS UAV System is free software; you can redistribute it
 **    and/or modify it under the terms of the GNU General Public
 **    License as published by the Free Software Foundation; either
 **    version 2 of the License, or (at your option) any later version.
 **
 **    HORUS UAV System is distributed in the hope that it will be
 **    useful, but WITHOUT ANY WARRANTY; without even the implied
 **    warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 **    See the GNU General Public License for more details.
 **
 **    You should have received a copy of the GNU General Public
 **    License along with the HORUS UAV System; if not, write to the
 **    Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 **    Boston, MA 02111-1307 USA
 **
 *********************************************************************/

/** \file
 **   
 ** This file declares two inline functions to generate delay loops in
 ** milli and micro seconds. This funtions are for compatibility only
 ** as they are now implemented using the standard avr-libc functions.
 **
 ********************************************************************/

#ifndef __DELAY_H__
#define __DELAY_H__

#ifndef S_SPLINT_S
#include "f_cpu.h"
#include <util/delay.h>
#endif



static inline void delay_us(uint16_t us) { _delay_us(us); } // The maximal possible delay is 768 us / F_CPU in MHz.
static inline void delay_ms(uint8_t ms)  { _delay_ms(ms); } // The maximal possible delay is 262.14 ms / F_CPU in MHz.

#endif /* __DELAY_H__ */
