/*********************************************************************
**   Martial Chateauvieux
**   HORUS UAV System
**   20 Fevrier 2003
**********************************************************************
**
**    HORUS UAV System V1.1.0 - Copyright (C) 2003-2009 Martial
**    Chateauvieux
**
**    This file is part of the HORUS UAV System distribution.
**
**    HORUS UAV System is free software; you can redistribute it
**    and/or modify it under the terms of the GNU General Public
**    License as published by the Free Software Foundation; either
**    version 2 of the License, or (at your option) any later version.
**
**    HORUS UAV System is distributed in the hope that it will be
**    useful, but WITHOUT ANY WARRANTY; without even the implied
**    warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
**    See the GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public
**    License along with the HORUS UAV System; if not, write to the
**    Free Software Foundation, Inc., 59 Temple Place, Suite 330,
**    Boston, MA 02111-1307 USA
**
*********************************************************************/

#include <inttypes.h>
#include <avr/interrupt.h>
#include <avr/io.h>

#include <stdio.h>

#include "tick.h"

/*==========================================================
** Global variables
**========================================================*/
volatile unsigned int TCK_5ms;
/*========================================================*/

/*==========================================================
** MATCH COMPARE A interupt handler
**========================================================*/
SIGNAL(SIG_OUTPUT_COMPARE1B) {
    OCR1B += TCK_5MS;
    TCK_tick();
}
/*========================================================*/

/*==========================================================
** Initialize the servo_pos array
**========================================================*/
void TCK_init () {

    // Prepare internal structures
    
    uint8_t sreg = SREG;	// Backup interrupt flag
    cli();
    
    // Configure counter 1 & Compare register A & B
    TCCR1B |= _BV(CS10);	// Prescaler == CK (Start counter 1)
    TIMSK  |= _BV(OCIE1B);	// Timer 1 Cmp match B intr. enab.
    
    OCR1B = TCNT1 + TCK_5MS;
    
    SREG = sreg;		// Restore interrupt flag
}
/*========================================================*/
