/*********************************************************************
**   Martial Chateauvieux
**   HORUS UAV System
**   30 Novembre 2003
**********************************************************************
**
**    HORUS UAV System V1.1.0 - Copyright (C) 2003-2009 Martial
**    Chateauvieux
**
**    This file is part of the HORUS UAV System distribution.
**
**    HORUS UAV System is free software; you can redistribute it
**    and/or modify it under the terms of the GNU General Public
**    License as published by the Free Software Foundation; either
**    version 2 of the License, or (at your option) any later version.
**
**    HORUS UAV System is distributed in the hope that it will be
**    useful, but WITHOUT ANY WARRANTY; without even the implied
**    warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
**    See the GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public
**    License along with the HORUS UAV System; if not, write to the
**    Free Software Foundation, Inc., 59 Temple Place, Suite 330,
**    Boston, MA 02111-1307 USA
**
*********************************************************************/

/** \file
 **   
 ** The Tick module implements a set of watchdog instances that are
 ** ticked by a 16bits Compare Match INTERUPT handler.
 **
 ********************************************************************/

#ifndef __TICK_H__
#define __TICK_H__

#include "project_config.h"
#include "hw_config.h"
#include "watchdog.h"

#define TCK_5MS		(5 * (SYSCLK / 1000))	// 5ms

/*==========================================================
** Global variables
**========================================================*/
extern volatile unsigned int TCK_5ms;
/*========================================================*/

void TCK_init();
static inline void TCK_tick() {
    TCK_5ms++;
}

#endif /* __TICK_H__ */
