/*********************************************************************
**   Martial Chateauvieux
**   HORUS UAV System
**   20 Fevrier 2003
**********************************************************************
**
**    HORUS UAV System V1.1.0 - Copyright (C) 2003-2009 Martial
**    Chateauvieux
**
**    This file is part of the HORUS UAV System distribution.
**
**    HORUS UAV System is free software; you can redistribute it
**    and/or modify it under the terms of the GNU General Public
**    License as published by the Free Software Foundation; either
**    version 2 of the License, or (at your option) any later version.
**
**    HORUS UAV System is distributed in the hope that it will be
**    useful, but WITHOUT ANY WARRANTY; without even the implied
**    warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
**    See the GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public
**    License along with the HORUS UAV System; if not, write to the
**    Free Software Foundation, Inc., 59 Temple Place, Suite 330,
**    Boston, MA 02111-1307 USA
**
*********************************************************************/

#include <stdio.h>

#include "watchdog.h"

/*==========================================================
** Global variables
**========================================================*/

/*==========================================================
** 
**========================================================*/
void WDG_init(volatile WDG_data_t *wdg,
	      const uint8_t max_value) {
    wdg->wtchdg_value = max_value;
    WDG_reset(wdg);
}

/*==========================================================
** 
**========================================================*/
void WDG_tick(volatile WDG_data_t *wdg) {
    if (++wdg->tick_count >= wdg->wtchdg_value) {
	wdg->fired = 1;
    }
}

/*==========================================================
** 
**========================================================*/
void WDG_reset(volatile WDG_data_t *wdg) {
    wdg->tick_count = wdg->fired = 0;
}
