/*********************************************************************
**   Martial Chateauvieux
**   HORUS UAV System
**   30 Novembre 2003
**********************************************************************
**
**    HORUS UAV System V1.1.0 - Copyright (C) 2003-2009 Martial
**    Chateauvieux
**
**    This file is part of the HORUS UAV System distribution.
**
**    HORUS UAV System is free software; you can redistribute it
**    and/or modify it under the terms of the GNU General Public
**    License as published by the Free Software Foundation; either
**    version 2 of the License, or (at your option) any later version.
**
**    HORUS UAV System is distributed in the hope that it will be
**    useful, but WITHOUT ANY WARRANTY; without even the implied
**    warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
**    See the GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public
**    License along with the HORUS UAV System; if not, write to the
**    Free Software Foundation, Inc., 59 Temple Place, Suite 330,
**    Boston, MA 02111-1307 USA
**
*********************************************************************/

/** \file
 **   
 ** This file the watchdog used to trigger regular events like
 ** blinking leds or start of the PPM frame generation.
 **
 ********************************************************************/

#ifndef __WCHDG_H__
#define __WCHDG_H__

#include <inttypes.h>

typedef struct  {
    uint8_t tick_count;
    uint8_t wtchdg_value;
    uint8_t fired;
} WDG_data_t;

void WDG_init(volatile WDG_data_t *wdg,
	      const uint8_t max_value);
void WDG_tick(volatile WDG_data_t *wdg);
void WDG_reset(volatile WDG_data_t *wdg);
inline extern uint8_t WDG_fired(volatile WDG_data_t *wdg) { return wdg->fired; }

#endif /* __WCHDG_H__ */
